library angular2.src.core.pipes.pipe_binding;

import "package:angular2/src/facade/lang.dart" show Type;
import "package:angular2/di.dart"
    show Key, Dependency, ResolvedBinding, Binding;
import "../metadata/directives.dart" show PipeMetadata;

class PipeBinding extends ResolvedBinding {
  String name;
  PipeBinding(
      this.name, Key key, Function factory, List<Dependency> dependencies)
      : super(key, factory, dependencies) {
    /* super call moved to initializer */;
  }
  static PipeBinding createFromType(Type type, PipeMetadata metadata) {
    var binding = new Binding(type, toClass: type);
    var rb = binding.resolve();
    return new PipeBinding(metadata.name, rb.key, rb.factory, rb.dependencies);
  }
}
