library angular2.src.core.pipes.pipes;

import "package:angular2/src/facade/lang.dart"
    show isBlank, isPresent, BaseException, Type;
import "package:angular2/di.dart"
    show
        Injectable,
        OptionalMetadata,
        SkipSelfMetadata,
        Binding,
        Injector,
        bind;
import "pipe_binding.dart" show PipeBinding;
import "package:angular2/src/change_detection/pipes.dart" as cd;

class ProtoPipes {
  /**
   * Map of [PipeMetadata] names to [PipeMetadata] implementations.
   */
  Map<String, PipeBinding> config = {};
  ProtoPipes(List<PipeBinding> bindings) {
    bindings.forEach((b) => this.config[b.name] = b);
  }
  PipeBinding get(String name) {
    var binding = this.config[name];
    if (isBlank(binding)) throw new BaseException(
        '''Cannot find pipe \'${ name}\'.''');
    return binding;
  }
}

class Pipes implements cd.Pipes {
  ProtoPipes proto;
  Injector injector;
  Pipes(this.proto, this.injector) {}
  dynamic get(String name) {
    var b = this.proto.get(name);
    return this.injector.instantiateResolved(b);
  }
}
