library angular2.src.web_workers.worker.xhr_impl;

import "package:angular2/di.dart" show Injectable;
import "package:angular2/src/facade/async.dart" show Future;
import "package:angular2/src/render/xhr.dart" show XHR;
import "package:angular2/src/web-workers/worker/broker.dart"
    show FnArg, UiArguments, MessageBroker;

/**
 * Implementation of render/xhr that relays XHR requests to the UI side where they are sent
 * and the result is proxied back to the worker
 */
@Injectable()
class WebWorkerXHRImpl extends XHR {
  MessageBroker _messageBroker;
  WebWorkerXHRImpl(this._messageBroker) : super() {
    /* super call moved to initializer */;
  }
  Future<String> get(String url) {
    List<FnArg> fnArgs = [new FnArg(url, null)];
    UiArguments args = new UiArguments("xhr", "get", fnArgs);
    return this._messageBroker.runOnUiThread(args, String);
  }
}
